//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2012, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern double     RiskPercent=2;
extern double     RewardRatio=2;
extern string     Trail_Type_Settings="1=MaTrail, 2=Normal,3= CandleTrail";
extern int        Trail_Type=1;
extern string     Ma_Trail_Settings;
extern int        MA_Period=60;
extern int        MA_PadAmount=0;
extern string     Trailing_Stop_Settings;
extern int        WhenToTrail=30;
extern int        TrailAmount=30;
extern string     Candle_Trail_Settings;
extern int        CandlesBack=5;
extern int        Candle_PadAmount=0;
extern string     MoveToBreakeven_Settings;
extern bool       UseMoveToBreakEven=False;
extern int        WhenToMoveToBE=20;
extern int        PipsToLockIn=3;
extern int        CandlesBeforeBiasObtained=12;
extern int        OrderPrice_PadAmount=0;
bool              Use_MA_Trail;
bool              UseTrailingStop;
bool              UseCandleTrail;
bool              Result;
bool              DeleteOrder;
bool              CloseHalfLong;

double            pips;
int               MagicNumber=1234;

datetime          triggerBarTime=0;
string            Bias="none";
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   switch(Trail_Type)
     {
      case 0:break;
      case 1:Use_MA_Trail=True;break;
      case 2:UseTrailingStop=True;break;
      case 3:UseCandleTrail=True;break;
      default:Use_MA_Trail=True;break;
     }
   double ticksize=MarketInfo(Symbol(),MODE_TICKSIZE);
   if(ticksize==0.00001 || ticksize==0.001) // if you set this to 0 it WONT throw an order out straight away.
      pips=ticksize*10;
   else pips=ticksize;
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

int start()
   {
   if(IsNewCandle())
      {
      CheckForMaTrade();//signals, deletions and candle trails only need checked on a new candle.
      if(UseCandleTrail)AdjustTrail();
      }

   if(OpenOrdersThisPair(Symbol())>0)
      {
      if(UseMoveToBreakEven)MoveToBreakEven();//Move to b/e, normal trail and MA_trail need to trail on each tick
      if(UseTrailingStop)AdjustTrail();//you don't want to wait an hour for your trail to move after a pinbar. or NFP
      if(Use_MA_Trail)MA_Trail();
      }
   }
//+----------------------------------------------------------------------------------------------------------------------------------------+  
//| Function that checks for an MA Cross                                                                                                   |
//+----------------------------------------------------------------------------------------------------------------------------------------+   

void CheckForMaTrade()
   {
   double CurrentSmallFish1   =  iMA(NULL,60,3,0,1,0,1);
   double CurrentSmallFish2   =  iMA(NULL,60,5,0,1,0,1);
   double CurrentSmallFish3   =  iMA(NULL,60,8,0,1,0,1);
   double CurrentSmallFish4   =  iMA(NULL,60,10,0,1,0,1);
   double CurrentSmallFish5   =  iMA(NULL,60,12,0,1,0,1);
   double CurrentSmallFish6   =  iMA(NULL,60,15,0,1,0,1);
   double CurrentBigFish1     =  iMA(NULL,60,30,0,1,0,1);
   double CurrentBigFish2     =  iMA(NULL,60,35,0,1,0,1);
   double CurrentBigFish3     =  iMA(NULL,60,40,0,1,0,1);
   double CurrentBigFish4     =  iMA(NULL,60,45,0,1,0,1);
   double CurrentBigFish5     =  iMA(NULL,60,50,0,1,0,1);
   double CurrentBigFish6     =  iMA(NULL,60,60,0,1,0,1);
   double ema21               =  iMA(NULL,60,21,0,1,0,1);

   // Check for Moving Averages Fanned up creating an UP bias.
   if(Bias=="none")
      if(CurrentSmallFish1>CurrentSmallFish2)
         if(CurrentSmallFish2>CurrentSmallFish3)
            if(CurrentSmallFish3>CurrentSmallFish4)
               if(CurrentSmallFish4>CurrentSmallFish5)
                  if(CurrentSmallFish5>CurrentSmallFish6)
                     if(CurrentSmallFish6>CurrentBigFish1)
                        if(CurrentBigFish1>CurrentBigFish2)
                           if(CurrentBigFish2>CurrentBigFish3)
                              if(CurrentBigFish3>CurrentBigFish4)
                                 if(CurrentBigFish4>CurrentBigFish5)
                                    if(CurrentBigFish5>CurrentBigFish6)
                                       {
                                       triggerBarTime=Time[1];
                                       Bias="up";
                                       Comment("Bias is: "+Bias+" since: "+TimeToStr(triggerBarTime,TIME_DATE|TIME_MINUTES));
                                       }
   
   //////////////////////////////////////////////////////////////////////////////////////   
   if(Bias=="up" && Low[1]<ema21 && Close[1]>CurrentBigFish6)
      {
      OrderEntry(0);
      }
   if(Bias=="up" && Close[1]<CurrentBigFish6)
      {
      Bias="none";
      Comment("Bias is: "+Bias+" since: "+TimeToStr(triggerBarTime,TIME_DATE|TIME_MINUTES));
      DeleteOrder();
      }
   
   ////////////////////////////////////////////////////////////////////////////////////
   // Check for Moving Averages Fanned down creating an DOWN bias.  
   if(Bias=="none")
      if(CurrentSmallFish1<CurrentSmallFish2)
         if(CurrentSmallFish2<CurrentSmallFish3)
            if(CurrentSmallFish3<CurrentSmallFish4)
               if(CurrentSmallFish4<CurrentSmallFish5)
                  if(CurrentSmallFish5<CurrentSmallFish6)
                     if(CurrentSmallFish6<CurrentBigFish1)
                        if(CurrentBigFish1<CurrentBigFish2)
                           if(CurrentBigFish2<CurrentBigFish3)
                              if(CurrentBigFish3<CurrentBigFish4)
                                 if(CurrentBigFish4<CurrentBigFish5)
                                    if(CurrentBigFish5<CurrentBigFish6)
                                       {
                                       triggerBarTime=Time[1];
                                       Bias="down";
                                       Comment("Bias is: "+Bias+" since: "+TimeToStr(triggerBarTime,TIME_DATE|TIME_MINUTES));
                                       }
   
   ///////////////////////////////////////////////////////////////////////////////////////
   if(Bias=="down" && High[1]>ema21 && Close[1]<CurrentBigFish6)
      {
      OrderEntry(1);
      }

   if(Bias=="down" && Close[1]>CurrentBigFish6)
      {
      Bias="none";
      Comment("Bias is: "+Bias+" since: "+TimeToStr(triggerBarTime,TIME_DATE|TIME_MINUTES));
      DeleteOrder();
      }

   //////////////////////////////////////////////////////////////////////////////////////
   }

//+------------------------------------------------------------------+
//| Order Enter Function                                             |
//+------------------------------------------------------------------+
void OrderEntry(int direction)
   {
   //determine amount to risk on this trade based on RiskPercent Above.
   double LotSize=0;
   double Equity=AccountEquity();
   double RiskedAmount=Equity*RiskPercent*0.01;

   //Get Highest Price in our lookback range and set buy price above it.
   int iTBT = iBarShift(NULL,60, triggerBarTime, true),
   iHH = iHighest(NULL,60, MODE_HIGH, iTBT + CandlesBeforeBiasObtained, 0);
   double buyPrice = High[iHH] + OrderPrice_PadAmount * pips;

   //Get Lowest Price in our lookback range and set sell price below it.
   datetime iTBT_1 = iBarShift(NULL, 60, triggerBarTime, true),
   iLL = iLowest(NULL, 60, MODE_LOW, iTBT_1 + CandlesBeforeBiasObtained, 0);
   double sellPrice=Low[iLL]-OrderPrice_PadAmount*pips;

   //get our buystop price from below the ma and our takeprofit based on our r:r ratio.
   double buy_stop_price=iMA(NULL,60,MA_Period,0,1,0,1)-MA_PadAmount*pips;
   double pips_to_bsl=buyPrice-buy_stop_price;
   double buy_takeprofit_price=(pips_to_bsl*RewardRatio)+buyPrice;

   double First_Target_Long=(pips_to_bsl*RewardRatio/2)+buyPrice;// First_Target holds a PRICE value.

   //get our sellstop price from below the ma and our takeprofit based on our r:r ratio.
   double sell_stop_price=iMA(NULL,60,MA_Period,0,1,0,1)+MA_PadAmount*pips;
   double pips_to_ssl=sell_stop_price-sellPrice;
   double sell_takeprofit_price=sellPrice-(pips_to_ssl*RewardRatio);


   //+-------------------------------------------------------------------------------------+
   //| Order Buy Function                                                                  |
   //+-------------------------------------------------------------------------------------+   

   //Place a pending buystop if no orders exists.. pending or otherwise.
   if(direction==0)
      { //--Buy--//

      double bsl=buy_stop_price;
      double btp=buy_takeprofit_price;
      LotSize=(RiskedAmount/(pips_to_bsl/pips))/10;

      if(OpenOrdersThisPair(Symbol())==0)
         {
         int BuyTicketOrder= OrderSend(Symbol(),OP_BUYSTOP,LotSize,buyPrice,3,bsl,btp,NULL,MagicNumber,0,Green);
         if(BuyTicketOrder == -1)Print("First Buy Order Last Error = ",GetLastError());
         } 

      for(int b=OrdersTotal()-1; b>=0; b--)
         {
         if(OrderSelect(b,SELECT_BY_POS,MODE_TRADES)==true)
            Print(" Stop loss value for the order is ",OrderStopLoss());

         else Print(" OrderSelect failed error code is ",GetLastError());

         if(OrderStopLoss()<iMA(NULL,0,MA_Period,0,1,0,0)-MA_PadAmount*pips)
            if(OrderMagicNumber()==MagicNumber)
               if(OrderSymbol()==Symbol())
                  if(OrderType()==OP_BUYSTOP)
                     if(OrderStopLoss()<iMA(NULL,0,MA_Period,0,1,0,0)-MA_PadAmount*pips)
                        //if(OpenOrdersThisPair(Symbol())==1)
                        {
                        DeleteOrder = OrderDelete(OrderTicket());
                        if(DeleteOrder != TRUE) Print("Buy Delete Order Last Error = ",GetLastError());
                        }

         if(OpenOrdersThisPair(Symbol())==0)// If there are no open orders = place a new order.
            {
            int NewBuyOrder= OrderSend(Symbol(),OP_BUYSTOP,LotSize,buyPrice,3,bsl,btp,NULL,MagicNumber,0,Green);
            if(NewBuyOrder == -1)Print("New Buy Order Last Error = ",GetLastError());
            if(NewBuyOrder>0)Print("NEW BUY ORDER:- Lots to open: ",DoubleToStr(LotSize,Digits)," Entry Price: ",DoubleToStr(buyPrice,Digits),
               " Buy Stop Loss: ",DoubleToStr(bsl,Digits)," Buy Take Profit: ",DoubleToStr(btp,Digits)," Magic Number is: ",DoubleToStr(MagicNumber,Digits));
            }
         }
      }   // end of  if(direction==0)

   ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 

   //+--------------------------------------------------------------------------------------------------+
   //| Close OP_BUY Half lots @ 1:1 Function                                                            |
   //+--------------------------------------------------------------------------------------------------+
   double minLot=MarketInfo(Symbol(),MODE_MINLOT);
   Print("The minimum lots are: ",DoubleToStr(minLot,Digits));

   double lotStep=MarketInfo(Symbol(),MODE_LOTSTEP);
   Print("The Lotstep is: ",DoubleToStr(lotStep,Digits));

   double half=MathCeil(OrderLots()/2/lotStep)*lotStep;
   Print("The Lots to close is: ",DoubleToStr(half,Digits));

   for(int c=OrdersTotal()-1; c>=0; c--)
      {
      if(OrderSelect(c,SELECT_BY_POS,MODE_TRADES)==true)
         {
         Print("Order Ticker Number = ",OrderTicket());
         Print("Order Lots Open = ",OrderLots());
          }
      else
          {
          Print("Order Select returned the error of ",GetLastError()); // Order Select does not seem to want to work?
          continue;
          }
      
      double FirstTarget_Sell=OrderOpenPrice() -(( OrderTakeProfit()-OrderOpenPrice())/2);
      Print("FirstTarget_Sell: ",DoubleToStr(FirstTarget_Sell,Digits));
      
      double FirstTarget_Buy=OrderOpenPrice()+(( OrderTakeProfit()-OrderOpenPrice())/2);
      Print("FirstTarget_Buy: ",DoubleToStr(FirstTarget_Buy,Digits));
      
      if(OrderMagicNumber()==MagicNumber)
         if(OrderSymbol()==Symbol())
            {
            Print("Current Bid: ",DoubleToStr(Bid,Digits)," FirstTarget_Buy: ",DoubleToStr(FirstTarget_Buy,Digits));
            
            if(OrderType()==OP_BUY && Bid>=FirstTarget_Buy+(Point/2)) // Doesn't seem to even go further than this as I do not get an error from OrderClose?
               {
               Print("Bid >= FirstTarget_Buy - Current Bid: ",DoubleToStr(Bid,Digits)," FirstTarget_Buy: ",DoubleToStr(FirstTarget_Buy,Digits));
               bool Close_Half_Order_Buy=OrderClose(OrderTicket(),half,Bid,3,CLR_NONE);
               if(Close_Half_Order_Buy!=TRUE)Print("Close_Half_Order_Buy Last Error = ",GetLastError());
               }
            }
      }

   /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

   //+---------------------------------------------------------------------------------------+
   //|Order Sell Function                                                                    |
   //+---------------------------------------------------------------------------------------+   

   if(direction==1)
      {//--Sell--//
      double ssl=sell_stop_price;
      double stp=sell_takeprofit_price;
      LotSize=(RiskedAmount/(pips_to_ssl/pips))/10;

      if(OpenOrdersThisPair(Symbol())==0)
         {
         int SellTicketOrder=OrderSend(Symbol(),OP_SELLSTOP,LotSize,sellPrice,3,ssl,stp,NULL,MagicNumber,0,Red);
         }

      
      for(int o=OrdersTotal()-1; o>=0; o--)   
         {
         if(OrderSelect(o,SELECT_BY_POS,MODE_TRADES)==true)
            Print(" Stop loss value for the order is ",OrderStopLoss());
            
         else Print(" OrderSelect failed error code is ",GetLastError());

         if(OrderMagicNumber()==MagicNumber)
            if(OrderSymbol()==Symbol())
               if(OrderType()==OP_SELLSTOP)
                  if(OrderStopLoss()>iMA(NULL,0,MA_Period,0,1,0,0)+MA_PadAmount*pips)
                     if(OrderStopLoss()>iMA(NULL,0,MA_Period,0,1,0,0)+MA_PadAmount*pips)
                        //if(OpenOrdersThisPair(Symbol())==1)
                        {
                        DeleteOrder=OrderDelete(OrderTicket());
                        if(DeleteOrder!=TRUE)Print("Sell Delete Order Last Error = ",GetLastError());
                        } 

         if(OpenOrdersThisPair(Symbol())==0)
            {
            int NewSellOrder= OrderSend(Symbol(),OP_SELLSTOP,LotSize,sellPrice,3,ssl,stp,NULL,MagicNumber,0,Green);
            if(NewSellOrder == -1)Print("New Sell Order Last Error = ",GetLastError());
            }
         }

      }
   }
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////  

//+------------------------------------------------------------------+
//| Delete Order Function                                            |
//+------------------------------------------------------------------+

void DeleteOrder()
   {

   for(int i=OrdersTotal()-1; i>=0; i--) //  <-- for loop to loop through all Orders . .   COUNT DOWN TO ZERO !
     {
      if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;   // <-- if the OrderSelect fails advance the loop to the next PositionIndex
      if(OrderMagicNumber()==MagicNumber && 
         OrderSymbol()==Symbol() && 
         OrderType()>OP_SELL)
         if(!OrderDelete(OrderTicket(),CLR_NONE)) // <-- try to close the order
            Print("Order Delete failed, order number: ",OrderTicket()," Error: ",GetLastError());  // <-- if the Order Close failed print some helpful information 

     } //  end of For loop

  }
//+----------------------------------------------------------------------------------------------------------------------------------------+
// Move to break even function  
//+----------------------------------------------------------------------------------------------------------------------------------------+ 


void MoveToBreakEven()
  {
   for(int b=OrdersTotal()-1; b>=0; b--)
     {
      if(OrderSelect(b,SELECT_BY_POS,MODE_TRADES))
         if(OrderMagicNumber()==MagicNumber)
            if(OrderSymbol()==Symbol())
               if(OrderType()==OP_BUY)
                  if(Bid-OrderOpenPrice()>WhenToMoveToBE*pips)
                     if(OrderOpenPrice()>OrderStopLoss())
                        OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+(PipsToLockIn*pips),OrderTakeProfit(),0,CLR_NONE);
     }
   for(int s=OrdersTotal()-1; s>=0; s--)
     {
      if(OrderSelect(s,SELECT_BY_POS,MODE_TRADES))
         if(OrderMagicNumber()==MagicNumber)
            if(OrderSymbol()==Symbol())
               if(OrderType()==OP_SELL)
                  if(OrderOpenPrice()-Ask>WhenToMoveToBE*pips)
                     if(OrderOpenPrice()<OrderStopLoss())
                        OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-(PipsToLockIn*pips),OrderTakeProfit(),0,CLR_NONE);
     }
  }
//+----------------------------------------------------------------------------------------------------------------------------------------+  
//Trailing Stop Function---
//+----------------------------------------------------------------------------------------------------------------------------------------+   
void AdjustTrail()

  {
   int buyStopCandle=iLowest(NULL,0,1,CandlesBack,0);
   int sellStopCandle=iHighest(NULL,0,2,CandlesBack,0);

//buy order section - This is where the stop will trail based upon a fixed point value stated on the EA. It will trail with price.
   for(int b=OrdersTotal()-1; b>=0; b--)
     {
      if(OrderSelect(b,SELECT_BY_POS,MODE_TRADES))
         if(OrderMagicNumber()==MagicNumber)
            if(OrderSymbol()==Symbol())
               if(OrderType()==OP_BUY)
                  if(UseCandleTrail)
                    {
                     if(OrderStopLoss()<Low[buyStopCandle]-Candle_PadAmount*pips) // The [] is the candlestick in question - 1 being the first bar closed - 3 would qualify for 3 bar stop...
                        OrderModify(OrderTicket(),OrderOpenPrice(),Low[buyStopCandle]-Candle_PadAmount*pips,OrderTakeProfit(),0,CLR_NONE);
                    }
      else if(Bid-OrderOpenPrice()>WhenToTrail*pips)
      if(OrderStopLoss()<Bid-pips*TrailAmount)
         OrderModify(OrderTicket(),OrderOpenPrice(),Bid-(pips*TrailAmount),OrderTakeProfit(),0,CLR_NONE);

     }
//sell order section - This is where the stop will trail based upon a fixed point value stated on the EA. It will trail with price.     
   for(int s=OrdersTotal()-1; s>=0; s--)
     {
      if(OrderSelect(s,SELECT_BY_POS,MODE_TRADES))
         if(OrderMagicNumber()==MagicNumber)
            if(OrderSymbol()==Symbol())
               if(OrderType()==OP_SELL)
                  if(UseCandleTrail)
                    {
                     if(OrderStopLoss()>High[sellStopCandle]+Candle_PadAmount*pips)// The [] is the candlestick in question - 1 being the first bar closed - 3 would qualify for 3 bar stop...
                        OrderModify(OrderTicket(),OrderOpenPrice(),High[sellStopCandle]+Candle_PadAmount*pips,OrderTakeProfit(),0,CLR_NONE);
                    }
      else if(OrderOpenPrice()-Ask>WhenToTrail*pips)
      if(OrderStopLoss()>Ask+TrailAmount*pips || OrderStopLoss()==0)
         OrderModify(OrderTicket(),OrderOpenPrice(),Ask+(pips*TrailAmount),OrderTakeProfit(),0,CLR_NONE);

     }

  }
//+----------------------------------------------------------------------------------------------------------------------------------------+  
//Moving Average Trailing Stop Function
//+----------------------------------------------------------------------------------------------------------------------------------------+   
void MA_Trail()

  {

//buy order section - This is where the stop will trail based upon a fixed point value stated on the EA. It will trail with price.
   for(int b=OrdersTotal()-1; b>=0; b--)
     {
      if(OrderSelect(b,SELECT_BY_POS,MODE_TRADES))
         if(OrderMagicNumber()==MagicNumber)
            if(OrderSymbol()==Symbol())
               if(OrderType()==OP_BUY)
                  if(OrderStopLoss()<iMA(NULL,0,MA_Period,0,1,0,0)-MA_PadAmount*pips)
                     OrderModify(OrderTicket(),OrderOpenPrice(),iMA(NULL,0,MA_Period,0,1,0,0)-MA_PadAmount*pips,OrderTakeProfit(),0,CLR_NONE);

     }
//sell order section - This is where the stop will trail based upon a fixed point value stated on the EA. It will trail with price.     
   for(int s=OrdersTotal()-1; s>=0; s--)
     {
      if(OrderSelect(s,SELECT_BY_POS,MODE_TRADES))
         if(OrderMagicNumber()==MagicNumber)
            if(OrderSymbol()==Symbol())
               if(OrderType()==OP_SELL)
                  if(OrderStopLoss()>iMA(NULL,0,MA_Period,0,1,0,0)+MA_PadAmount*pips)
                     OrderModify(OrderTicket(),OrderOpenPrice(),iMA(NULL,0,MA_Period,0,1,0,0)+MA_PadAmount*pips,OrderTakeProfit(),0,CLR_NONE);

     }

  }
//+----------------------------------------------------------------------------------------------------------------------------------------+  
//| Check to see if any order open on this currency pair                                                                                   |
//+----------------------------------------------------------------------------------------------------------------------------------------+   

int OpenOrdersThisPair(string pair)
  {
   int total=0;
   for(int i=OrdersTotal()-1; i>=0; i--)
     {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==pair) total++;
     }
   return(total);
  }
// If there is an order open, it will not place a new one^


//+----------------------------------------------------------------------------------------------------------------------------------------+   
//| Ensuring its a new candle function                                                                                                     |
//+----------------------------------------------------------------------------------------------------------------------------------------+   
bool IsNewCandle()
   {
   static datetime  Bar1Time;
   if(Bar1Time == Time[1]) //"Time" used to be "Bars" with no brackets - I changed it based upon MQL4 thread and RaptorUK advise? Not sure if I've done it right though?
      return(false);
      
   Bar1Time = Time[1]; //"Time" used to be "Bars" with no brackets - I changed it based upon MQL4 thread and RaptorUK advise? Not sure if I've done it right though?
   return(true);
   }

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////